#include "asm86.h"         
#include "ti86asm.inc"

_setxxop1                        equ            4613h
_setxxop2			 equ		4617h		
_convop1                         equ            5577h		
_fpmult                          equ            548Ch		
_CPOP1OP2                        equ            41FBh
_setxxxxop2                      equ            461Bh
_fpadd                           equ            5478h
_op5toop1       		 equ            4247h
_op2toop5 	      	 	 equ            4257h

_divHLby10	=	$4044		;divide HL by 10
Digits		=	3		;number of digits to print



.org _asm_exec_ram 

;------------------------AShell Description ------------------------------

	nop         ;Identifies the table
	jp init
.dw $0000   ;Version # of Table
.dw Title   ;Absolute pointer to program description

;------------------------Begin the Program--------------------------------
init:
	call	_clrLCD			;Clears the Screen
	call	_runindicoff		;Turns the RunIndicator Off
	ld 	hl,0			;0->hl
	ld 	(score),hl		;hl->score
	ld 	a,1			;1->a
	ld 	(round),a		;a->current round (1 to start)
	ld 	bc,$2000		;initial delay length (2000)->bc
	ld 	(dlay),bc		;bc->dlay
	jp	title			;Jumps to display title
		
;------------------------Displays the Title Screen---------------------------
title:
 call    _clrLCD			;Clear the Screen
 set  3,(IY+05)
 ld   HL,0
 ld   (_curCol),HL
 ld   HL,Title
 call _puts
 res  3,(IY+05)
 ld   de,$0810
 ld   hl,CREDITS1
 call PutText
 ld   de,$1013
 ld   hl,CREDITS2
 call PutText
 ld   de,$1806
 ld   hl,CONTROLS
 call PutText
 ld   de,$2010
 ld   hl,SECONDSHOOTS
 call PutText
 ld   de,$2810
 ld   hl,ENTERPAUSE
 call PutText
 ld   de,$3010
 ld   hl,EXITQUITS
 call PutText
 ld   a,$50
 ld   e,$25
 ld   hl,drwu
 call PutSprite
 ld   a,$65
 ld   e,$27
 ld   hl,gun
 call PutSprite
 call GET_KEY
titleloop:
 call GET_KEY
 cp   K_EXIT
 ret  z
 cp   K_ENTER
 jr   z,Start
 jr   titleloop


;---------------------------Pause and wait for Enter ------------------------------
Pause:
	halt				;Save some Energy =)
	call	GET_KEY			;Wait for a KeyPress
	cp	K_ENTER			;If you pressed Enter?
	jp	nz,Pause		;No?  Goto Pause Again
	ret				;Otherwise, return to Call Location
	
;---------------------Puts the BackGround on the Screen ---------------------
putBG:
	LD DE,$FC00
	LD BC,1024
	LD HL,PIC_DUCKHUNT		;Pic Name for Loading
	ldir				;Sends to the Screen
	ret
;----------------------------Start Game ---------------------------------------
Start:
	call varInit			;Variable Init
	call nrInit			;New Round Init
	call ndInit			;Initialize Duck
	call _clrLCD
	call putBG
	call PutGun			;Put the Gun
	jr   Loop			;Goto Loop

NewRound:
	call nrInit			;Initialize Round
	call _clrLCD
	call putBG
	
NewDuck:
	call ndInit			;Initialize Duck
	call PutGun			;Put the Gun
Loop:
	call dispScore
	call LoadDuck			;Loads the Duck
	ld a,(ducky)			;Duck Y Coordinate into A
	ld e,a				;That into E
	ld a,(duckx)			;Duck X into A
	call PutSprite
	jp GetKeyLoop
	
NoKey:
	jr SkipDelay
	
SkipDelay:
	ld a,(moves)		;moves->a
	cp 200			;has the duck moved # times?
	jp z,flyaway		;if so, fly away
	call LoadDuck		;Load Duck
	ld a,(ducky)		;ducky->a
	ld e,a			;a->e
	ld a,(duckx)		;duckx->a
	call PutSprite		;Clear it!
	jp chwing		;call routine to change wing

wingch:				;return from chwing. (Wing status changed)
	jp chkdloc		;check duck's location (if on any edges,
				;change movement direction.)
rchk:				;return from check
	call dmove		;move duck!
	jp Loop			;go to beginning of duck moving routine

;------change wing (up or down)----
chwing:
	ld a,(wing)			;wing->a
	inc a				;a+1->a
	ld (wing),a			;a->wing
	cp 3				;is a 3?
	jp nz,wingch			;if not, goto wing changed (it must be 2)
	ld a,1				;(else, reset wing to 1)... 1->a
	ld (wing),a			;a->wing
	jp wingch			;return from chwing


;-------Erase Duck/Gun-------
erdc:
	ld a,(guny)			;Loads GunY into A
	ld e,a				;A into E
	ld a,(gunx)			;GunX into A
	ld hl,gun			;Gun into HL
	call PutSprite			;Clear the Sprite!
	call LoadDuck			;Load DuckSprite
	ld a,(ducky)			;Load DuckY into A
	ld e,a				;Loads A into E
	ld a,(duckx)			;Loads DuckX into A
	call PutSprite			;Clear it!
	ret				;Return

;---------display score---------
dispScore:
	ld hl,57*256+59		;penrow=57,pencol=58
	ld (_penCol),hl		;set those coords
	ld hl,(score)		;score->hl
	call DispHL
	ret				;return
	
;-------move duck------------
dmove:
	ld a,(moves)		;moves->a
	inc a			;a+1->a
	ld (moves),a		;a->moves
	ld a,(dirlr)		;dirlr->a
	cp 1			;is duck moving right?
	jp z,inca		;if so, increment duckx
	ld a,(duckx)		;duckx->a
	dec a			;a-1->a
	ld (duckx),a		;into duckx

rinc:				;return from inc
	ld a,(dirud)		;dirud->a
	cp 1			;is duck moving up?
	jp z,deca		;if so, goto decrement a
	ld a,(ducky)		;ducky->a
	inc a			;a+1->a
	ld (ducky),a
	ret

inca:
	ld a,(duckx)		;duckx->a
	inc a			;a+1->a
	ld (duckx),a		;back into duckx
	jp rinc			;return from increment
deca:
	ld a,(ducky)		;ducky->a
	dec a			;a-1->a
	ld (ducky),a
	ret

;--------duck fly away------
flyaway:
	call erdc		;erase duck and cursor
	ld  de,$1422		;penrow=20,pencol=34
	ld hl,fas		;fly away string
	call PutText		;put string on graph!
flyaway1:
	ld a,(ducky)		;duck y-coord->a
	ld e,a			;a->e
	ld a,(duckx)		;duck x-coord->a
	ld hl,faway		;faway sprite->bc
	call PutSprite		;call SPRXOR routine
	call delay		;delay
	ld a,(ducky)		;duck y-coord->a
	ld e,a			;a->e
	ld a,(duckx)		;duck x-coord->a
	ld hl,faway		;faway sprite->bc
	call PutSprite		;call SPRXOR routine
	ld a,(ducky)		;duck y-coord->a
	cp 0			;top of the screen? (a=0?)
	jp z,fadvance		;if so, goto fadvance
	dec a			;a-1->a (to decrease y-coord)
	ld (ducky),a		;a->duck y-coord
	jp flyaway1		;loop!

;------check duck's location-------------
chkdloc:
	ld a,87		
	ld b,a
	ld a,(duckx)
	cp b
	jp nc,MakeDir2
	ld a,(duckx)
	cp 1
	jp z,MakeDir1
	jr nz,nchk

nchk:
	ld a,(ducky)		;ducky->a (duck's y-coord)
	cp 1			;is y-coord 1?
	jp z,chdirud		;if so, goto change duck's ud direction
	cp 38			;is y-coord 38?
	jp z,chdirud		;if so, goto change duck's ud direction
	jp rchk


MakeDir2:
	ld a,2
	ld (dirlr),a
	jr nchk

MakeDir1:
	ld a,1
	ld (dirlr),a
	jr nchk


chdirud:			;change duck's ud movement
	ld a,(dirud)		;dirud->a
	inc a			;a+1->a
	ld (dirud),a		;a->dirud
	cp 3			;is dirud 3?
	jp nz,rchk		;if not, return (that means dirud is 2)
	ld a,1			;(otherwise... set it back to 1) 1->a
	ld (dirud),a		;a->dirud
	jp rchk			;return from chk


;----KeyLoop----
GetKeyLoop:
	ld	bc,$1000
	ld	(dlay),bc
	call 	delay			;Create a delay
	ld	bc,$2000
	ld	(dlay),bc
	ld 	a,0ffh			;Reset keyport
	out 	(1),a			;Clear Port
	ld 	a,0feh			;Load desired port
	out     (1),a			;Clear Keys
	in 	a,(1)			;Input Key
	cp	251			;If key is right
	jp 	z,GunRight		;Goto Right
	cp 	253			;If key is left
	jp 	z,GunLeft		;Goto Left
	cp	247			;Is it key Up
	jp	z,GunUp			;Move Up
	cp	254			;Is it Down
	jp	z,GunDown		;Move Down	
	ld 	a,0ffh			;Reset keyport
	out 	(1),a			;Clear Port
	ld 	a,0bfh			;Load desired port
	out     (1),a			;Clear Keys
	in 	a,(1)			;Input Key
	cp 	223			;Is it 2nd
	jp 	z,shoot			;Shoot if so
	cp	127			;Is it delete
	jp	z,QuickPause		;Pause
	cp	191			;Is it Exit [Note - would result in Key Mode on 83]
	ret	z			;Return from Program if so
	jp	nz,NoKey		;NoKey Otherwise

QuickPause:
	halt
	call GET_KEY
	cp K_NOKEY
	jp z,QuickPause
	jp nz,GetKeyLoop


;--------put move (of gun)---------
PutMove:
	call PutGun			;re-display crosshairs
	jp SkipDelay			;return from gtkey, skipping delay

;-----Keys to Move-----
GunUp:
	ld a,(guny)			;gun y-coord->a
	cp 0				;a=0? (top of screen?)
	jp z,NoKey			;if so, NoKey
	call ClearGun
	ld a,(guny)			;gun y-coord->a
	dec a				;a-1->a (to move up)
	dec a				;a-1->a (to move up)
	ld (guny),a			;a->gun y-coord
	jr PutMove			;put gun move

GunDown:
	ld a,(guny)			;gun y-coord->a
	cp 38				;a=38? (grass line?)
	jp z,NoKey			;if so, goto NoKey
	call ClearGun
	ld a,(guny)			;gun y-coord->a
	inc a				;a+1->a (to move down)
	inc a				;a+1->a (to move down)
	ld (guny),a			;a->gun y-coord
	jp PutMove			;put gun move

GunLeft:
	ld a,(gunx)			;gun x-coord->a
	cp 0				;a=0? (left side of screen)
	jp z,NoKey			;if so, goto NoKey
	call ClearGun
	ld a,(gunx)			;gun x-coord->a
	dec a				;a-1->a (to move left)
	dec a				;a-1->a (to move left)
	ld (gunx),a			;a->gun x-coord
	jp PutMove			;put gun move

GunRight:
	ld a,(gunx)			;gun x-coord->a
	cp 88				;a=88? (right side of screen)
	jp z,NoKey			;if so, goto NoKey
	call ClearGun
	ld a,(gunx)			;gun x-coord->a
	inc a				;a+1->a (to move right)
	inc a				;a+1->a (to move right)
	ld (gunx),a			;a->gun x-coord
	jp PutMove			;Put GunMove

;--------shoot gun!---------
shoot:
	ld a,(guny)
	ld e,a
	ld a,(gunx)
	ld hl,gun
	call PutSprite
	ld a,(guny)			;gun y-coord->a
	ld e,a				;a->e
	ld a,(gunx)			;gun x-coord->a
	ld hl,shot			;sprite shot->bc
	call PutSprite			;call Movax's sprite routine
	call delay			;delay
	call delay			;delay
	call delay			;delay
	ld a,(guny)			;gun y-coord->a
	ld e,a				;a->e            
	ld a,(gunx)			;gun x-coord->a		
	ld hl,shot			;sprite shot->bc
	call PutSprite			;call Movax's sprite routine
	ld a,(guny)
	ld e,a
	ld a,(gunx)
	ld hl,gun
	call PutSprite

;---------erase a bullet------
erasebul:
 ld   hl,$390E
 ld   (_penCol),hl
 ld   a,(bullets)
 cp   10
 call z,Write10
 add  a,'0'
 call M_CHARPUT

;---------check for hit-------
CheckForHit:
 ld   a,(gunx)         ;Loads Gun X into A
 add  a,4              ;add 4 to A [Middle of Sprite]
 ld   b,a              ;Loads A into B
 ld   a,(duckx)        ;Loads Duck X into A
 cp   b                ;Compares  a to b
 jp   c,ContinueCheck ;Continue Checking if a>b
 jr   subbull          ;Missed Otherwise

ContinueCheck:
 ld   a,(duckx)    ;Duck X into A
 add  a,4          ;add 4 to A
 ld   b,a          ;Loads A into B
 ld   a,(gunx)     ;Gun X into A
 cp   b            ;Compare A to B
 jp   c,CheckYHit ;If b>a then check Y-Coord
 jp   subbull     ;You missed otherwise

CheckYHit:
 ld   a,(guny)          ;Loads Gun X into A
 add  a,4               ;add 4 to A
 ld   b,a               ;Loads A into B
 ld   a,(ducky)         ;Loads Duck X into A
 cp   b                 ;Compares a to b
 jp   c,ContinueCheckY ;Continue Checking if a>b
 jr   subbull           ;Missed Otherwise

ContinueCheckY:
 ld   a,(ducky) ;Duck X into A
 add  a,4       ;add 4 to A 
 ld   b,a       ;Loads A into B
 ld   a,(guny)  ;Gun X into A
 cp   b         ;Compare A to B
 jp   c,hit    ;If b>a then Hit!!!
 jp   subbull  ;You missed otherwise



;---------subtract bullet from remaining--------
subbull:
 ld   a,(bullets)  ;bullets left->a
 dec  a ;a-1->a
 ld   (bullets),a  ;a->bullets
 or   a            ;zero? (out of bullets?)
 jp   z,flyaway   ;if so, goto flyaway!
 ld   hl,$390E
 ld   (_penCol),hl
 ld   a,(bullets)
 cp   10
 call z,Write10
 add  a,'0'
 call M_CHARPUT
 jp   NoKey       ;return from getkey

;-----------A HIT!!!----------------
hit:
	call erdc			;erase duck and cursor!
	ld a,(dhit)			;ducks hit->a
	inc a				;a+1->a
	ld (dhit),a			;a->ducks hit
	;------------update score------------
	 ld   a,(bullets) ;bullets remaining->a
         ld   h,a
         ld   a,15        ;15->a
         ld   l,a
         call MUL_HL
         ld   de,(score)
         add  hl,de
         ld   (score),hl  ;hl->score

hitloop:
	ld a,(ducky)			;duck y-coord->a
	ld e,a				;a->e
	ld a,(duckx)			;duck x-coord->a
	ld hl,hitduck			;sprite hitduck->bc
	call PutSprite			;call movax's sprite routine
	call delay			;delay
	ld a,(ducky)			;duck y-coord->a
	ld e,a				;a->e
	ld a,(duckx)			;duck x-coord->a
	ld hl,hitduck			;sprite hitduck->bc
	call PutSprite			;call movax's sprite routine
	ld a,(ducky)			;duck y-coord->
	inc a				;a+1->a (make him go one more down the screen)
	ld (ducky),a			;a->duck y-coord
	cp 42				;is it 38? (grass line?)
	jp nz,hitloop			;if not, loop again
	jp advance

;----------advance stats---------
fadvance:				;This simply deletes the text that says "FlyAway"   
 ld   de,$1422
 ld   (_penCol),de
 ld   b,32
delloop:
 ld a,32
 call M_CHARPUT
 djnz delloop

advance:				;advance duck, round, or even END of game
	ld a,(curduck)			;current duck #->a
	cp 10				;duck #10? (new round?)
	jp z,rndovr			;if so, goto round over
	ret z
	inc a				;a+1->a (increase current duck #)
	ld (curduck),a			;a->current duck #
	jp NewDuck			;new duck!

;---------round over--------------
rndovr:
	ld   de,$0A0A		;penrow=20,pencol=10
	;-----Show how many hit/needed-------
	ld hl,youhit		;"You hit "
	call PutText		;put string on graph
	ld a,(dhit)		;# ducks hit->a
	call DispA
	ld hl,andneed		;" and needed "
	call _vputs		;put string on graph
	ld a,(needed)		;# needed to advance->a
	call DispA
	;---------Check for round clear!--------
	ld a,(dhit)		;# needed to advance->a
	inc a			;Increase it, so that if they are =, it works out
	ld b,a
	ld a,(needed)
	cp b
	jp nc,exit
	;-----if you've made it here, ROUND CLEAR!---------
	ld   de,$141C		;penrow=30,pencol=28
	ld hl,rndclr		;"Round Clear!"
	call PutText		;put string on graph!
	ld a,(dhit)		;# ducks hit->a
	cp 10			;did you hit all 10 ducks?
	jp nz,noperfect		;if not skip perfect, goto NOPERFECT!
 ld   hl,(score)    ;score->hl
 ld   de,250
 add  hl,de
 ld   (score),hl    ;hl->score
 ld   de,34         ;Row=0,Col=34
 ld   hl,perfect   ;"PERFECT!"
 call PutText      ;put string on graph
 ld   de,21         ;Row=10,Col=21
 ld   hl,bonus     ;"250 point BONUS!"
 call PutText      ;put string on graph

noperfect:
	call Pause
	call delay			;delay
	call delay			;delay
	call delay			;delay
	call delay			;delay
	ld   a,(round)     ;round #->a
 	cp   5             ;round #5?
 	jp   z,winner     ;if so, you win!
 	inc  a             ;a+1->a
 	ld   (round),a     ;a->round
 	ld   hl,(dlay)     ;dlay->hl
 	ld   de,$FA00
 	add  hl,de
 	ld   (dlay),hl
 	jp   NewRound     ;new round!!!


;--------WINNER!-------------
winner:
 call _clrLCD     ;Clear the Screen
 ld   de,7          ;Row=0,Col=7
 ld   hl,congrats1 ;first line of congrats string
 call PutText      ;put string on graph!
 ld   de,$0609      ;Row=6,Col=9
 ld   hl,congrats2 ;second line of congrats string
 call PutText      ;put string on graph!
 ld   de,$0C0E      ;Row=12,Col=14
 ld   hl,Congrats3 ;third line of congrats string
 call PutText      ;put string on graph!
 ld   de,$1200      ;Row=18,Col=0
 ld   hl,congrats4 ;fourth line of congrats string
 call PutText      ;put string on graph!

exit:
 ld   hl,29*256+33     ;Row=29,Col=33
 ld   (_penCol),hl     ;Into PenCol
 ld   hl,gameover      ;"GAME OVER!"
 call _vputs           ;put string on graph!
 ld   hl,37*256+10     ;Row=37,Col=30
 ld   (_penCol),hl
 ld   hl,scr           ;"SCORE = "
 call _vputs           ;Display it!
 ld   hl,37*256+90
 ld   (_penCol),hl
 ld   hl,(score)   ;score->hl
 call DispHL
 call Pause
 call _clrLCD
 ret

;----------Initialize new round stuff--------------
nrInit:					;new round initialize
	call _clrLCD			;clear screen
	call putBG
	ld a,44				;44->a
	ld (gunx),a			;a->gun x-coord
	ld a,20				;20->a
	ld (guny),a			;a->gun y-coord
	ld a,1				;1->a
	ld (curduck),a			;a->current duck (1)
	ld a,0				;0->a
	ld (dhit),a			;a->dhit (no ducks hit yet! duh)
	ld a,(round)			;round->a
	ld b,a				;a->b
	ld a,5				;5->a
	add a,b				;a+b->a
	ld (needed),a			;a->needed
	ld hl,10*256+35			;penrow=20,pencol=35
	ld (_penCol),hl			;set these coords
	ld hl,rnd			;"Round "
	call _vputs			;put string on graph!
	ld hl,10*256+60			;penrow=20,pencol=60
	ld (_penCol),hl			;into PenCol
	ld a,(round)			;round->hl
	call DispA			;Display it!
	ld hl,20*256+20			;penrow=30,pencol=15
	ld (_penCol),hl			;set these coords
	ld hl,hits			;hit string "Hit "
	call _vputs			;put string on graph!
	ld hl,20*256+28			;penrow=30,pencol=30
	ld (_penCol),hl			;Into PenCol
	ld a,(needed)			;Needed to hl
	call DispA			;Display it
	ld hl,20*256+40			;Coords
	ld (_penCol),hl			;hl into PenCol
	ld hl,outof10			;" out of 10 ducks!"
	call _vputs			;put string
	call Pause			;wait for key
	call delay			;delay
	call delay			;delay
	call delay			;delay
	ret				;return from new round initialize

varInit:
	ld a,0			;0->a
	ld (score),a		;a->score
	ld a,1			;1->a
	ld (round),a		;a->current round (1 to start)
	ld bc,$2000		;initial delay length (2000)->bc
	ld (dlay),bc		;bc->dlay
	ret

;-----------Initialize new duck stuff----------------
ndInit:				;new duck initialize
	ld a,44			;44->a
	ld (gunx),a		;a->gun x-coord
	ld a,20			;20->a
	ld (guny),a		;a->gun y-coord
	ld a,3			;3->a
	ld (bullets),a		;a->bullets
	ld hl,57*256+10
	ld (_penCol),hl
	ld a,(bullets)
	call DispA
	ld a,1			;1->a
	ld (wing),a		;a->wing
	ld (moves),a		;a->moves
	ld (dirud),a		;a->dirud
	ld a,37			;37->a
	ld (ducky),a		;a->ducky
	ld a,85			;85->a  (85 is max num for random)
	ld (temp),a		;a->temp
	call Random		;call random routine... # from 1 - a
	ld (duckx),a		;a->duckx (a contains the random #)
	ld a,2			;2->a (2 is max num for random)
	ld (temp),a		;a->temp
	call Random		;random # generator
	cp 1			;Is it 1?
	call Load1DirLR		;Load 1
	call nz,Load2DirLR	;Load 2
	ld hl,57*256+26		;penrow=57,pencol=26
	ld (_penCol),hl		;set those coords
	ld a,(curduck)		;current duck->a
	call DispA		;display!
	ld hl,57*256+43		;penrow=57,pencol=43
	ld (_penCol),hl		;set those coords
	ld a,(dhit)		;ducks hit->a
	call DispA		;Display it!
	ret			;return from new duck initialize

Load1DirLR:
	ld a,1
	ld (dirlr),a
	ret

Load2DirLR:
	ld a,2
	ld (dirlr),a
	ret

;---------display gun---------

PutGun:
	ld a,(guny)			;gun y-coord->a
	ld e,a				;a->e
	ld a,(gunx)			;gun x-coord->a
	ld hl,gun			;sprite gun->hl
	call PutSprite			;PutSprite
	ret				;return

ClearGun:
	ld a,(guny)
	ld e,a
	ld a,(gunx)
	ld hl,gun
	call PutSprite
	ret
	

;--------random # routine... number between 1 and (temp)---------------
Random:
	call	_RANDOM
	ld	a,(temp)
	call	_setxxop2
	call	_fpmult
	call	_convop1
	ld	a,e
	ret

;------ld which sprite (direction and wing up or down)----
LoadDuck:
	ld a,(wing)			;wing->a
	cp 2				;wing down?
	jp z,down			;if so,jump to down
	ld a,(dirlr)			;dirlr->a
	cp 2				;left?
	jp z,uleft			;if so, jump to (facing) up,left
	ld hl,drwu			;if none of these, sprite drwu->bc 
	ret				;duck loaded
uleft:
	ld hl,dlwu			;sprite dlwu->bc
	ret				;duck loaded
down:
	ld a,(dirlr)			;dirlr->a
	cp 2				;left?
	jp z,dleft			;if so,jump to (facing) down,left
	ld hl,drwd			;otherwise, sprite drwd->bc
	ret 				;jp duckldd
dleft:
	ld hl,dlwd			;sprite dlwd->bc
	ret	 			;jp duckldd


PutText:
 ld (_penCol),de
 call _vputs
 ret


;-----Display HL Routine [By: SCaBBy]-----
DispA:
 ld l,a
 ld h,0
DispHL:					;dipslay 5 digits from hl
 xor a
 ld de,-1
 ld (_curRow),de
 call 4A33h
 dec hl
 jp _vputs

;-----delay loop--------
delay:
	PUSH AF			;hide current AF value
	PUSH BC			;hide current BC value 
	LD BC,(dlay)		;dlay length->bc
delayLoop:
	DEC BC			;bc-1->bc
	LD A, B			;Loads b into a
	OR C			;Checks if c=0
	JR NZ, delayLoop	;if not, continue loop	
	POP BC			;unhide current BC value
	POP AF			;unhide current AF value 
	ret

Write10:
 ld   A,$31
 call M_CHARPUT
 sub A
 ret

;------------------
; Sprite Routine [XOR]
;------------------

;------------------
;This Routine was converted by AVD from Movax's 83
;Special thanks to ScaBBy for making it XOR Routine!
;------------------

;hl = image
;a = x coord
;e = y coord

PutSprite:
       push    hl              ; Save sprite address

;   Calculate the address in graphbuf   

        ld      hl,0            ; Do y*12
        ld      d,0
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl

        ld      d,0             ; Do x/8
        ld      e,a
        srl     e
        srl     e
        srl     e
        add     hl,de

        ld      de,$FC00
        add     hl,de           ; Add address to graphbuf

        ld      b,00000111b     ; Get the remainder of x/8
        and     b
        cp	0               ; Is this sprite aligned to 8*n,y?
        jp      z,ALIGN


;   Non aligned sprite blit starts here   

        pop     ix              ; ix->sprite
        ld      d,a             ; d=how many bits to shift each line

        ld      e,8             ; Line loop
LILOP:  ld      b,(ix+0)        ; Get sprite data

        ld      c,0             ; Shift loop
        push    de
SHLOP:  srl     b
        rr      c
        dec     d
        jp      nz,SHLOP
        pop     de

        ld      a,b             ; Write line to graphbuf
        xor     (hl)
        ld      (hl),a
        inc     hl
        ld      a,c
        xor     (hl)
        ld      (hl),a

        ld      bc,15           ; Calculate next line address
        add     hl,bc
        inc     ix              ; Inc spritepointer

        dec     e
        jp      nz,LILOP        ; Next line

        jp      DONE1


;   Aligned sprite blit starts here   

ALIGN:                          ; Blit an aligned sprite to graphbuf
        pop     de              ; de->sprite
        ld      b,8
ALOP1:  ld      a,(de)
        xor      (hl)            ; xor=erase/blit
        ld      (hl),a
        inc     de
        push    bc
        ld      bc,16
        add     hl,bc
        pop     bc
        djnz    ALOP1

DONE1:
        ret
; SPRITE 


;-----------------------Include File for BGround ---------------------------

#include "dhunt.asm"			;Graphic is Saved in this File

;--------------------------------Sprites----------------------------------

gun:					
 .db 00000000b
 .db 00000000b
 .db 00100100b
 .db 00011000b
 .db 00011000b
 .db 00100100b
 .db 00000000b
 .db 00000000b

drwu:					
	.db	01000000b
	.db	01100011b
	.db	00110100b
	.db	01111000b
	.db	11110000b
	.db	01000000b
	.db	00000000b
	.db	00000000b
drwd:					
	.db	00000011b
	.db	00000100b
	.db	01111000b
	.db	11111000b
	.db	01001100b
	.db	00000000b
	.db	00000000b
	.db	00000000b
dlwu:					
	.db	00000010b
	.db	11000110b
	.db	00101100b
	.db	00011110b
	.db	00001111b
	.db	00000010b
	.db	00000000b
	.db	00000000b
dlwd:					
	.db	11000000b
	.db	00100000b
	.db	00011110b
	.db	00011111b
	.db	00110010b
	.db	00000000b
	.db	00000000b
	.db	00000000b

faway:				
	.db	00001000b
	.db	00001000b
	.db	00011100b
	.db	00111110b
	.db	01101011b
	.db	00101010b
	.db	00010100b
	.db	00000000b

shot:					
	.db	00000000b
	.db	01000010b
	.db	00101000b
	.db	00010100b
	.db	00101100b
	.db	00010010b
	.db	01001000b
	.db	00000000b

hitduck:				
	.db	00000100b
	.db	00010100b
	.db	00011110b
	.db	00011110b
	.db	00011100b
	.db	00001000b
	.db	00001000b
	.db	00000000b

;-------------------------Begin Text Strings ------------------------------
Title:		.db "  DuckHunt 86  v1.5 ",0

CREDITS1:
 .db "Original by "
 .db "Andrew Ungvarsky",0
CREDITS2:
 .db "TI-86 port by"
 .db " Ahmed El-Helw",0
CONTROLS:      .db "Thanks to Crayman for Graphics",0
SECONDSHOOTS:  .db "[2nd] - fire",0
ENTERPAUSE:    .db "[MORE] - pause",0
EXITQUITS:     .db "[EXIT] - quit",0
		
rnd:		.db 	"Round ",0
hits:		.db 	"Hit ",0
outof10		.db 	" out of 10 ducks!",0
fas:		.db 	"Fly Away!",0
rndclr:		.db 	"Round Clear!",0
youhit:		.db 	"You hit ",0
andneed:	.db 	" and needed ",0
prsclr:		.db 	"(Press Enter)",0
gameover	.db 	"GAME OVER",0
congrats1	.db 	"Congratulations! You are",0
congrats2	.db 	"a hunting machine. BUT,",0
Congrats3	.db 	"since I hate hunting,",0
congrats4	.db 	"there`s no cool ending. SORRY!",0
scr:		.db 	"SCORE = ",0
perfect:	.db 	"PERFECT!",0
bonus:		.db 	"250 point BONUS!",0
blankaway:	.db	"                  ",0


;----------------------Define All Needed Variables-------------------------

varspace	=$
duckx		=varspace		;Duck X Coord
ducky		=varspace+1		;Duck Y Coord
wing:		=varspace+2		;Wing Up/Down (1-Up, 2-Down)
dirlr:		=varspace+3		;Moving Left/Right (1-Right, 2-Left)
dirud:		=varspace+4		;Moving Up/Down (1-Up, 2-Down)
moves:		=varspace+5		;Number of Moves
temp:		=varspace+6		;Temporary Variable
gunx:		=varspace+7		;Gun X Coord
guny:		=varspace+8		;Gun Y Coord
score		=varspace+9		;Your Score
bullets:	=varspace+11		;Bullets Remaining
curduck:	=varspace+12		;Current Duck # (1-10)
needed:		=varspace+13		;Ducks Needed
dhit:		=varspace+14		;Number of Ducks Hit
round:		=varspace+15		;Round
dlay:		=varspace+16		;Delay Number
count:		=varspace+18		;For Input Loop

.end
END
